#!/usr/bin/python

import  sys
import os

pdir = os.path.dirname(os.getcwd())
sys.path.insert(0,pdir)    

import oootemplate as oo
from datetime import date

class User():
    def __init__(self, name, surname, address):
        self.name = name
        self.surname = surname
        self.address = address

class rs(object):
    def __init__(self, rs, address, manager, cap):
        self.rs = rs
        self.address = address
        self.manager = manager
        self.cap = cap
        
    def __str__(self):
        return self.rs

class Libro():
    def __init__(self, title, author, price, qta=1):
        self.title = title
        self.author = author
        self.price = price
        self.qta = qta


user = User(name='Peter', 
              surname='Gomez', 
              address='via Appia n.5',)

libro1 = Libro(title='Q',
             author='Luter Blisset',
             price=15, qta=3)

libro2 = Libro(title='The Da Vinci Code',
             author='Dan Brown',
             price=20,)

content = {'data'   : date(2009,9,27), # valore
           'user'  : user,
           'Tabella2'     : [libro1, libro2],
           'totale' : 3000,
           'rs'     : rs('Diade srl', 'V. Palestrina 20', user, '20040'),
           'qta'    : 2,
           'price'  : 33}

context = oo.Context(content)

print context.sub(key='user.name')

# Connessione Locale
filename = os.path.abspath('template__.odt')
templ = oo.Template(filename, server='127.0.0.1', port=8100)
templ.set_pattern('(?P<match>__(?P<var_name>[^ ]+)__)', '__[^ ]+__')


if len(sys.argv) > 1:
    templ.render(context)
    output_file = os.path.abspath(sys.argv[1])
    templ.save_as(output_file + '.pdf')
    print "written output in %s.pdf " % output_file 
    templ.save_as(output_file + '.odt')
    print "written output in %s.odt " % output_file 
    templ.document.close(True)

